<?php

namespace wpopt;
class Ajax
{
    static function init()
    {
        add_action('wp_ajax_' . Config::$plugin_name, array(static::class, 'ajax'));
        add_action('wp_ajax_nopriv_' . Config::$plugin_name, array(static::class, 'ajax'));
    }

    static function ajax()
    {
        $fun_name = $_POST['fun'];
        if (!isset($fun_name)) {
            $fun_name = $_GET['fun'];
            if (!isset($fun_name)) {
                $fun_name = 'error';
            }
        }
        self::$fun_name();
    }

    static function setAjaxDataAndDie($code, $msg = '', $data = null)
    {
        $_data['code'] = $code;
        $_data['msg'] = $msg;
        $_data['data'] = $data;
        wp_die(json_encode($_data));
    }


    static function saveSet()
    {
        $data = stripslashes($_POST['data']);
        $data = json_decode($data, true);
        $re = Config::saveSet($data);
        if ($re == false) {
            self::setAjaxDataAndDie(500, '你貌似没有更改设置哦');
        } else {
            self::setAjaxDataAndDie(200, '保存成功');
        }
    }

    static function needLogin()
    {
        if (!is_user_logged_in()) {
            self::setAjaxDataAndDie(500, '无权限访问');
        }
    }

    static function getPluginInfo()
    {
        self::needLogin();
        $data = Plugin::getServePluginInfo();
        if ($data !== false) {
            if ($data['version'] > Config::$plugin_version) {
                $data['update'] = 1;
            } else {
                $data['update'] = 0;
            }
            self::setAjaxDataAndDie(200, '获取成功', $data);
        } else {
            self::setAjaxDataAndDie(500, '获取失败');
        }
    }

    static function checkUpdate()
    {
        $set = Config::getSet();
        $plugin_info = Plugin::getServePluginInfo();

        if ($plugin_info !== false) {
            if ($plugin_info['version'] > Config::$plugin_version) {
                $set['update']['need_update'] = 1;
            } else {
                $set['update']['need_update'] = 0;
            }
        }
        $set['update']['last_check_time'] = time();
        Config::saveSet($set);
        self::setAjaxDataAndDie(200, 'check success');
    }

    static function uploadImage()
    {
        self::needLogin();
        $set = Config::getSet();
        $blob_name = $_POST['image_name'];
        $blob_type = $_POST['image_type'];
        $wp_file_type = wp_check_filetype($blob_name);
        $dir = wp_upload_dir();
        $upload_dir = $dir['path'];
        $file_name = Tools::getMicrotime() . '.' . $wp_file_type['ext'];
        $total_file_name = $upload_dir . "/$file_name";

        $moved = move_uploaded_file($_FILES['image']['tmp_name'], $total_file_name);
        if ($moved == false) {
            self::setAjaxDataAndDie(500, 'error', "上传图片失败");
        }

        if ($set['fun_enhance']['paste_upload_img_to_webp'] == 1 && extension_loaded('gd') && Tools::canToWebP($blob_type) === true) {
            $file_name = pathinfo($file_name, PATHINFO_FILENAME) . '.webp';
            if (Tools::imageToWebP($total_file_name, $upload_dir . "/$file_name", 80, $blob_type) == false) {
                unlink($total_file_name);
                self::setAjaxDataAndDie(500, '转换webp图片失败');
            }
            $total_file_name = $upload_dir . "/$file_name";
            $blob_type = "image/webp";
        }

        $attachment = array(
            'post_mime_type' => $blob_type,
            'post_title' => pathinfo($file_name, PATHINFO_FILENAME),
            'post_content' => '',
            'post_status' => 'inherit'
        );
        $attach_id = wp_insert_attachment($attachment, $total_file_name);
        $attach_data = wp_generate_attachment_metadata($attach_id, $total_file_name);
        wp_update_attachment_metadata($attach_id, $attach_data);
        self::setAjaxDataAndDie(200, 'success', $dir['url'] . "/$file_name");
    }

    static function updatePlugin()
    {
        $plugin_info = Plugin::getServePluginInfo();
        if ($plugin_info !== false) {
            if ($plugin_info['version'] > Config::$plugin_version) {
                //准备更新
                if (isset($plugin_info['down_url'])) {
                    $url = $plugin_info['down_url'];
                    $dir = WP_PLUGIN_DIR . '/tmp';
                    if (!is_dir($dir)) {
                        mkdir($dir);
                    }
                    $remote_file = fopen($url, 'r');
                    $file_name = time() . '.zip';
                    $fh = fopen($dir . "/{$file_name}", 'w');
                    while (!feof($remote_file)) {
                        $output = fread($remote_file, 8192);
                        fwrite($fh, $output);
                    }
                    fclose($remote_file);
                    $file_path = $dir . '/' . $file_name;
                    if (strtoupper(md5_file($file_path)) != $plugin_info['file_md5']) {
                        Tools::delDir($dir);
                        self::setAjaxDataAndDie(500, '更新失败，文件校验失败，请手动更新');
                    }

                    $zip = new \ZipArchive();
                    if ($zip->open($file_path) === true) {
                        $zip->extractTo(WP_PLUGIN_DIR);
                        $zip->close();
                    } else {
                        Tools::delDir($dir);
                        self::setAjaxDataAndDie(500, '解压失败，可能没有权限');
                    }
                    Tools::delDir($dir);
                    $set = Config::getSet();
                    $set['update']['need_update'] = 0;
                    Config::saveSet($set);
                    self::setAjaxDataAndDie(200, '更新成功，请刷新！');

                } else {
                    self::setAjaxDataAndDie(500, '更新失败，未获取到下载地址');
                }
            }
        }
    }
}