<?php

namespace wpopt;

class LoadFile
{
    static function init()
    {
        add_action('wp_enqueue_scripts', array(static::class, '_LoadFileOnSite'));
        add_action('admin_enqueue_scripts', array(static::class, '_LoadFileOnAdmin'));
        add_filter('mce_external_plugins', array(static::class, '_loadMcePlugins'));
    }

    static function _LoadFileOnSite()
    {
        /*      Tools::loadFileUrl('js', 'vue', 'https://cdn.staticfile.org/vue/2.6.9/vue.min.js');
              Tools::loadFileUrl('css', 'material-icons', 'https://cdn.staticfile.org/material-design-icons/3.0.2/iconfont/material-icons.min.css');
              Tools::loadFile('js', 'main', 'main.js', array('vue'), true);
              Tools::loadFile('css', 'main', 'main.css');*/
    }

    static function _loadMcePlugins($plugin_array)
    {
        $plugin_array['my_button_script'] = Config::$plugin_js_url . '/mce-plugins.js?v=' . Config::$plugin_version;
        return $plugin_array;
    }

    static function _LoadFileOnAdmin($hook)
    {
        Tools::loadFile('css', 'wpopt-admin', 'admin.css');
        Tools::loadFile('js', 'wpopt-admin', 'admin.js', [], true);
        wp_localize_script('wpopt-admin', Config::$plugin_name, Config::getAdminSetData($hook));

        if ($hook == 'toplevel_page_wpopt_set') {
            Tools::loadFile('js', 'vue', 'vue.min.js', array(), true);
            Tools::loadLib('js', 'tdesign', 'tdesign.min.js', array('vue'));
            Tools::loadLib('css', 'tdesign', 'tdesign.min.css');
            //Tools::loadLib('js', 'tdesign-icons-vue', 'index.min.js', array('vue'));
            //Tools::loadLib('css', 'tdesign-icons-vue', 'index.min.css');
            Tools::loadFile('css', 'set-main', 'admin-set.css');
            Tools::loadFile('js', 'set-main', 'admin-set.js', array('vue'), true);
        }
        if ($hook == 'post.php' || $hook == 'post-new.php') {
            Tools::loadFile('js', 'vue', 'vue.min.js', array(), true);
            Tools::loadLib('js', 'tdesign', 'tdesign.min.js', array('vue'));
            Tools::loadLib('css', 'tdesign', 'tdesign.min.css');
        }
    }
}