<?php

namespace wpopt;
class Plugin
{
    static function init()
    {
        add_action('admin_menu', array(static::class, 'regMenu'));

    }

    static function regMenu()
    {
        add_menu_page('WPOPT', 'WPOPT', 'administrator', 'wpopt_set', array(static::class, 'setPageSettings'),
            'dashicons-icon-wpopt');
    }

    static function setPageSettings()
    {
        require_once Config::$plugin_dir . '/page/set.php';
    }

    static function getServePluginInfo()
    {
        $url = Config::$plugin_server_url . '&site=' . get_bloginfo('url', 'display') . '&v=' . Config::$plugin_version;
        $request = new \WP_Http;
        $result = $request->request($url);
        if (!is_wp_error($result)) {
            $json = json_decode($result['body'], true);
            if ($json['code'] == 200) {
                $data['version'] = $json['data']['version'];
                $data['version_name'] = $json['data']['version_name'];
                $soft_data = json_decode($json['data']['data'], true);
                if ($soft_data !== false) {
                    $data['down_url'] = $soft_data['down_url'];
                    $data['file_md5'] = $soft_data['file_md5'];
                }
                return $data;
            }
        } else {
            return false;
        }
        return false;
    }
}