<?php

namespace wpopt;
class Tools
{
    static function loadFile($type, $name, $file_name, $need = array(), $footer = false)
    {
        if ($type == 'js') {
            wp_enqueue_script($name, Config::$plugin_js_url . "/{$file_name}", $need, Config::$plugin_version, $footer);

        } elseif ($type == 'css') {
            wp_enqueue_style($name, Config::$plugin_css_url . "/{$file_name}", $need, Config::$plugin_version);
        }
    }

    static function loadLib($type, $lib_name, $file_name, $need = array(), $footer = false)
    {
        if ($type == 'js') {
            wp_enqueue_script($lib_name, Config::$plugin_lib_url . "/{$lib_name}/{$file_name}", $need, Config::$plugin_version, $footer);

        } elseif ($type == 'css') {
            wp_enqueue_style($lib_name, Config::$plugin_lib_url . "/{$lib_name}/{$file_name}", $need, Config::$plugin_version);
        }
    }

    static function loadFileUrl($type, $name, $file_url, $need = array(), $footer = false)
    {
        if ($type == 'js') {
            wp_enqueue_script($name, $file_url, $need, Config::$plugin_version, $footer);
        } elseif ($type == 'css') {
            wp_enqueue_style($name, $file_url, $need, Config::$plugin_version);
        }
    }

    static function getImgUrl($name)
    {
        return Config::$plugin_static_url . "/img/{$name}";
    }

    static function delDir($dir)
    {
        //先删除目录下的文件：
        $dh = opendir($dir);
        while ($file = readdir($dh)) {
            if ($file != "." && $file != "..") {
                $fullpath = $dir . "/" . $file;
                if (!is_dir($fullpath)) {
                    unlink($fullpath);
                } else {
                    delDir($fullpath);
                }
            }
        }
        closedir($dh);
        //删除当前文件夹：
        if (rmdir($dir)) {
            return true;
        } else {
            return false;
        }
    }

    static function imageToWebP($file_name, $save_file_name, $quality = 80, $image_type = 'image/png')
    {
        $img_path = $file_name;
        $img_webp_path = $save_file_name;
        $im = null;

        switch ($image_type) {
            case 'image/png':
                $im = @imagecreatefrompng($img_path);
                break;
            case 'image/jpeg':
                $im = @imagecreatefromjpeg($img_path);
                break;
            case 'image/bmp':
                $im = @imagecreatefrombmp($img_path);
                break;
            default:
                return false;
        }

        if ($im == false) {
            return false;
        }
        if (!imagewebp($im, $img_webp_path, $quality)) {
            return false;
        }
        imagedestroy($im);
        unlink($file_name);
        return true;
    }

    static function getMicrotime()
    {
        list($s1, $s2) = explode(' ', microtime());
        return (float)sprintf('%.0f', (floatval($s1) + floatval($s2)) * 1000);
    }

    static function canToWebP($type)
    {
        $arr = array('image/bmp', 'image/jpeg', 'image/png');
        return in_array($type, $arr);
    }
}