<?php
namespace wpopt;
?>
<div id="wpopt">
    <div class="set-header">
        <div class="set-header-title-plane">
            <div>
                <img src="<?php echo Tools::getImgUrl('wpopt.svg')?>" width="60" style="margin-right: 20px">
            </div>
            <div>
                <div class="set-header-title"><?php _e('WPOPT- 设置中心', 'wpopt'); ?></div>
                <div class="set-header-version">
                    版本v<?php echo Config::$plugin_version_name; ?>
                </div>
            </div>
        </div>

    </div>
    <main>
        <div class="set-menu">
            <t-menu theme="light" :value="active_menu" :collapsed="collapsed_menu" @change="changeMenu" height="800px">
                <t-menu-item value="base">
                    <template #icon>
                        <t-icon name="logo-windows-filled"/>
                    </template>
                    <?php _e('基础信息', 'wpopt'); ?></t-menu-item>
                <t-menu-item value="echo">
                    <template #icon>
                        <t-icon name="chart-bubble"/>
                    </template>
                    <?php _e('输出优化', 'wpopt'); ?></t-menu-item>
                <t-menu-item value="fun_ban">
                    <template #icon>
                        <t-icon name="close-circle-filled"/>
                    </template>
                    <?php _e('函数禁用', 'wpopt'); ?></t-menu-item>
                <t-menu-item value="fun_switch">
                    <template #icon>
                        <t-icon name="bulletpoint"/>
                    </template>
                    <?php _e('功能开关', 'wpopt'); ?></t-menu-item>
                <t-menu-item value="optimization">
                    <template #icon>
                        <t-icon name="dashboard"/>
                    </template>
                    <?php _e('优化加速', 'wpopt'); ?></t-menu-item>
                <t-menu-item value="fun_enhance">
                    <template #icon>
                        <t-icon name="control-platform"/>
                    </template>
                    <?php _e('功能增强', 'update'); ?></t-menu-item>
                <t-menu-item value="about">
                    <template #icon>
                        <t-icon name="info-circle"/>
                    </template>
                    <?php _e('关于插件', 'wpopt'); ?></t-menu-item>
                <t-menu-item value="update">
                    <template #icon>
                        <t-icon name="star"/>
                    </template>
                    <?php _e('更新插件', 'update'); ?></t-menu-item>
            </t-menu>
        </div>
        <div class="set-main">
            <div v-if="active_menu=='base'">
                <?php
                require_once Config::$plugin_dir . '/page/set/base.php'
                ?>
            </div>
            <div v-if="active_menu=='echo'">
                <?php
                require_once Config::$plugin_dir . '/page/set/echo.php'
                ?>
            </div>
            <div v-if="active_menu=='fun_switch'">
                <?php
                require_once Config::$plugin_dir . '/page/set/fun-switch.php'
                ?>
            </div>
            <div v-if="active_menu=='fun_ban'">
                <?php
                require_once Config::$plugin_dir . '/page/set/fun-ban.php'
                ?>
            </div>
            <div v-if="active_menu=='optimization'">
                <?php
                require_once Config::$plugin_dir . '/page/set/optimization.php'
                ?>
            </div>
            <div v-if="active_menu=='about'">
                <?php
                require_once Config::$plugin_dir . '/page/set/about.php'
                ?>
            </div>
            <div v-if="active_menu=='update'">
                <?php
                require_once Config::$plugin_dir . '/page/set/update.php'
                ?>
            </div>
            <div v-if="active_menu=='fun_enhance'">
                <?php
                require_once Config::$plugin_dir . '/page/set/fun-enhance.php'
                ?>
            </div>
        </div>
    </main>
    <div class="control-plane">
        <t-button @click="saveSet" :loading="loading.save_btn">保存</t-button>
    </div>
</div>